'use strict';

var _commander = require('commander');

var _commander2 = _interopRequireDefault(_commander);

var _init = require('./init');

var _init2 = _interopRequireDefault(_init);

var _fs = require('fs');

var _fs2 = _interopRequireDefault(_fs);

var _path = require('path');

var _path2 = _interopRequireDefault(_path);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

_commander2.default.command('serve').alias('s').description('serve ap-npm').option('-c, --config', "config file to use").action(function (config) {
  var container = void 0;

  if (_fs2.default.existsSync(config)) {
    console.log("using config: " + config + '\n');
    container = (0, _init2.default)(config);
  } else {
    console.log("using default config\n");
    var configLocation = _path2.default.join(__dirname, '../', 'config.json');
    container = (0, _init2.default)(configLocation);
  }

  var command = container.get('command-serve');
  command.run();
});

_commander2.default.command('config [prop] [value]').description('list or set config properties').action(function (property, value) {
  var configLocation = _path2.default.join(__dirname, '../', 'config.json');
  var container = (0, _init2.default)(configLocation);
  var command = container.get('command-config');

  if (!property || !value) {
    command.listConfig(configLocation);
  } else {
    command.updateProp(property, value);
  }
});

_commander2.default.command('init').description('init a npm project using ap-npm publishConfig').action(function () {
  var container = (0, _init2.default)(_path2.default.join(__dirname, '../', 'config.json'));
  var command = container.get('command-init');
  command.run(process.cwd());
});

_commander2.default.parse(process.argv);

if (!process.argv.slice(2).length) {
  _commander2.default.outputHelp();
}