'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _fs = require('fs');

var _fs2 = _interopRequireDefault(_fs);

var _path = require('path');

var _path2 = _interopRequireDefault(_path);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var _class = function () {
  function _class(hostname, port, ssl) {
    _classCallCheck(this, _class);

    this.hostname = hostname;
    this.port = port;
    this.ssl = ssl;

    this.mutableProperties = {
      "workDir": 'string',
      "port": 'integer',
      "hostname": 'string',
      "ssl": 'boolean',
      "sslkey": "string",
      "sslcert": "string"
    };
  }

  _createClass(_class, [{
    key: 'listConfig',
    value: function listConfig(configLocation) {
      console.log('Config location: ' + configLocation);
      _fs2.default.readFile(configLocation, function (err, configData) {
        console.log("Config configuration:\n", JSON.parse(configData));
      });
    }
  }, {
    key: 'updateProp',
    value: function updateProp(property, value) {
      var configPath = _path2.default.join(__dirname, '../..', 'config.json');
      var configString = _fs2.default.readFileSync(configPath);
      var config = JSON.parse(configString);

      if (config.hasOwnProperty(property) !== true) {
        console.log("Error, property does not exist");
        return;
      } else if (this.mutableProperties.hasOwnProperty(property) !== true) {
        console.log("Error, cannot change this property from cli\n" + "changing all properties should be done using a config file");
        return;
      }

      // Convert values
      if (value === 'true') {
        value = true;
      } else if (value === 'false') {
        value = false;
      }

      if ((typeof value === 'undefined' ? 'undefined' : _typeof(value)) !== this.mutableProperties[property]) {
        console.log("Value is incorrect, aborting\n");
        return;
      }

      if (property === 'ssl') {
        config.ssl.enabled = value;
      } else if (property === 'sslkey') {
        config.ssl.sslkey = value;
      } else if (property === 'sslcert') {
        config.ssl.sslcert = value;
      } else {
        config[property] = value;
      }

      _fs2.default.writeFile(configPath, JSON.stringify(config, null, 2), function () {
        console.log("Property: '" + property + "' has been updated: " + value);
      });
    }
  }]);

  return _class;
}();

exports.default = _class;