'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

exports.default = function (container) {

  var storageLocation = _path2.default.join(container.get('config').workDir, container.get('config').storage.directory);
  try {
    if (!_fsExtra2.default.ensureDirSync(storageLocation)) {
      _fsExtra2.default.mkdirsSync(storageLocation);
    }
  } catch (err) {
    container.get('logger').error("Failed to initialize filesystem-structure in " + storageLocation);
  }

  container.set('storage-filesystem', function () {
    var Filesystem = require('../storage/filesystem/index').default;
    return new Filesystem(container.get('config'), container.get('logger'));
  });

  container.set('storage', function () {
    return container.get('storage-filesystem');
  });
};

var _path = require('path');

var _path2 = _interopRequireDefault(_path);

var _fsExtra = require('fs-extra');

var _fsExtra2 = _interopRequireDefault(_fsExtra);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }