'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _crypto = require('crypto');

var _crypto2 = _interopRequireDefault(_crypto);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var _class = function () {
  function _class(auth) {
    _classCallCheck(this, _class);

    this.auth = auth;
  }

  /*
  * First checks if user exists, if so -> login
  * If user doesn't exist -> try to create user
  */


  _createClass(_class, [{
    key: 'process',
    value: function process(httpRequest, httpResponse) {
      var _this = this;

      return new Promise(function (resolve, reject) {
        var userInfo = {
          username: httpRequest.body.name,
          password: httpRequest.body.password,
          email: httpRequest.body.email,
          type: httpRequest.body.type
        };
        var userLoggedIn = false;
        _this.loginUser(userInfo).then(function (result) {
          if (result === true) {
            userLoggedIn = true;
            _this.generateToken(userInfo).then(function (token) {
              httpResponse.status(201);
              httpResponse.send({
                token: token
              });
              resolve(userLoggedIn);
            });
          } else {
            _this.createUser(userInfo).then(function (result) {
              if (result === true) {
                userLoggedIn = true;
                _this.generateToken(userInfo).then(function (token) {
                  httpResponse.status(201);
                  httpResponse.send({
                    token: token
                  });
                  resolve(userLoggedIn);
                });
              } else {
                reject('Cannot create user');
              }
            });
          }
        });
      }).catch(function (error) {
        httpResponse.status(401);
        httpResponse.send("401, " + error);
      });
    }
  }, {
    key: 'createUser',
    value: function createUser(userInfo) {
      return this.auth.userAdd(userInfo.username, userInfo.password, userInfo.email);
    }
  }, {
    key: 'loginUser',
    value: function loginUser(userInfo) {
      return this.auth.userLogin(userInfo.username, userInfo.password, userInfo.email);
    }
  }, {
    key: 'generateToken',
    value: function generateToken(userInfo) {
      var _this2 = this;

      return new Promise(function (resolve) {
        var token = _crypto2.default.randomBytes(64).toString('hex');
        _this2.auth.addTokenToDB(userInfo.username, token);
        resolve(token);
      });
    }
  }]);

  return _class;
}();

exports.default = _class;