'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _semver = require('semver');

var _semver2 = _interopRequireDefault(_semver);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var _class = function () {
  function _class(storage, validator, config) {
    _classCallCheck(this, _class);

    this.storage = storage;
    this.packageValidator = validator;
    this.config = config;
  }

  /*
   * Reads package data from fileystem and sends it to npm-client
   */


  _createClass(_class, [{
    key: 'process',
    value: function process(httpRequest, httpResponse) {
      var _this = this;

      return new Promise(function (resolve, reject) {
        if (_this.config.auth.remove === false) {
          reject('403, not allowed to delete packages');
        }

        var packageName = httpRequest.body._packageName;
        var packageScope = httpRequest.body._scope;
        var referer = httpRequest.headers.referer;
        var packageVersion = void 0;

        if (referer.indexOf('@') > -1) {
          var spliced = referer.split('@');
          packageVersion = spliced[spliced.length - 1];
        } else {
          var _spliced = referer.split(' ');
          packageVersion = _spliced[0];
        }

        if (packageVersion === 'unpublish') {
          _this.storage.removePackage({
            name: packageName,
            scope: packageScope
          }).then(function (result) {
            if (result === true) {
              httpResponse.status(200);
              resolve(httpResponse.send({
                ok: "Package deleted"
              }));
            } else {
              reject("424, cannot delete package from filesystem");
            }
          });
        } else if (_semver2.default.valid(packageVersion)) {
          _this.storage.removePackageVersion({
            name: packageName,
            scope: packageScope,
            version: packageVersion
          }).then(function (result) {
            if (result === true) {
              httpResponse.status(200);
              resolve(httpResponse.send({
                ok: "Packageversion deleted"
              }));
            } else {
              reject("424, cannot delete package from filesystem");
            }
          });
        }
      }).catch(function (err) {
        httpResponse.send(err);
      });
    }
  }]);

  return _class;
}();

exports.default = _class;