'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

exports.default = function (request, storageLocation) {
  return new Promise(function (resolve, reject) {
    var packageName = request.name;
    var packageScope = request.scope;

    var jsonPath = void 0;
    if (packageScope) {
      jsonPath = _path2.default.join(storageLocation, packageScope, packageName, 'package.json');
    } else {
      jsonPath = _path2.default.join(storageLocation, packageName, 'package.json');
    }

    if (_fs2.default.existsSync(jsonPath)) {
      (0, _readJson2.default)(jsonPath).then(function (data) {
        resolve(data);
      });
    } else {
      reject("package.json does not exist");
    }
  });
};

var _fs = require('fs');

var _fs2 = _interopRequireDefault(_fs);

var _path = require('path');

var _path2 = _interopRequireDefault(_path);

var _readJson = require('./read-json');

var _readJson2 = _interopRequireDefault(_readJson);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }