'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

exports.default = function (request, storageLocation) {
  var packageName = request.name;
  var packageScope = request.scope;
  return new Promise(function (resolve) {
    var packagePath = void 0;
    if (packageScope) {
      packagePath = _path2.default.join(storageLocation, packageScope, packageName, 'package.json');
    } else {
      packagePath = _path2.default.join(storageLocation, packageName, 'package.json');
    }

    if (_fs2.default.existsSync(packagePath)) {
      resolve(true);
    }
    resolve(false);
  }).catch(function () {
    return false;
  });
};

var _path = require('path');

var _path2 = _interopRequireDefault(_path);

var _fs = require('fs');

var _fs2 = _interopRequireDefault(_fs);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }