'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

exports.default = function (request, storageLocation) {
  return new Promise(function (resolve, reject) {
    var packageName = request.name;
    var packageScope = request.scope;
    var packageLocation = void 0;

    if (packageScope) {
      packageLocation = _path2.default.join(storageLocation, packageScope, packageName);
    } else {
      packageLocation = _path2.default.join(storageLocation, packageName);
    }

    if (!_fs2.default.existsSync(_path2.default.join(packageLocation, 'package.json'))) {
      reject("Invalid request, aborting");
    }

    (0, _rimraf2.default)(packageLocation, function () {
      return resolve(true);
    });
  });
};

var _fs = require('fs');

var _fs2 = _interopRequireDefault(_fs);

var _path = require('path');

var _path2 = _interopRequireDefault(_path);

var _rimraf = require('rimraf');

var _rimraf2 = _interopRequireDefault(_rimraf);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }