'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _semver = require('semver');

var _semver2 = _interopRequireDefault(_semver);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var _class = function () {
  function _class(storage) {
    _classCallCheck(this, _class);

    this.storage = storage;
  }

  _createClass(_class, [{
    key: 'doesVersionExist',
    value: function doesVersionExist(packageName, packageVersion) {
      var _this = this;

      var packageScope = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : null;

      return new Promise(function (resolve) {
        _this.storage.isVersionAvailable(packageName, packageVersion, packageScope).then(function (result) {
          resolve(result);
        });
      });
    }

    // *** PUBLISHING ***

  }, {
    key: 'isVersionHigher',
    value: function isVersionHigher(packageName, packageVersion, distTag) {
      var _this2 = this;

      var packageScope = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : null;

      return new Promise(function (resolve) {
        _this2.storage.getPackageJson({
          name: packageName,
          scope: packageScope
        }).then(function (packageData) {
          var currentVersion = packageData['dist-tags'][distTag];
          resolve(_semver2.default.satisfies(packageVersion, '>' + currentVersion));
        });
      });
    }
  }, {
    key: 'hasDistTag',
    value: function hasDistTag(packageData, distTag) {
      var _this3 = this;

      var packageName = packageData._packageName;
      var packageScope = packageData._scope;

      return new Promise(function (resolve) {
        _this3.storage.getPackageJson(packageName, packageScope).then(function (packageJson) {
          resolve(!!packageJson['dist-tags'][distTag]);
        });
      });
    }
  }]);

  return _class;
}();

exports.default = _class;